
/*
	$ Drag Now! v2.01  (C) 2005-2011 mfboy
	$ static/dragnow.js
		+ 2011-07-19   2.01 汾
		+ 2011-07-14   IE 
		+ 2011-07-09  ļʼд
*/

(function () {

	if(typeof window.d != 'object') {
		return false;
	}
	if(typeof window.d.lang != 'object') {
		return false;
	} else if(typeof window.d.hash != 'string') {
		return false;
	} else if(typeof window.d.setting != 'object') {
		return false;
	}

	var d = window.d;
	window.d = null;

	/* ݻ */
	d.data = {

		'_forum': {},
		'_hidden': {},
		'_dname': {},
		'_name': {},

		'cate': function (fid) {
			return d.data._forum[fid] == -1 ? true : false;
		},

		'get': function (callback) {
			for(var fid in d.data._forum) {
				callback(fid);
			}
		},

		'getCate': function (callback) {
			d.html.get('d_cate[]', 'div', function (obj) {
				callback(obj.getAttribute('fid'), obj);
			});
		},

		'getForum': function (fup, callback) {
			for(var fid in d.data._forum) {
				if(d.data._forum[fid] == fup) {
					callback(fid);
				}
			}
		},

		'getForumByTag': function (fup, callback) {
			d.html.get('d_forum[]', 'tr', function (obj) {
				var fid = obj.getAttribute('fid');
				if(!fup || d.data._forum[fid] == fup) {
					callback(fid, obj);
				}
			});
		},

		'init': function () {
			d.data.initForum();
			d.data.initData();
		},

		'initData': function () {
			d.data.get(function (fid) {
				d.data._hidden[fid] = parseInt($('d_hidden_' + fid).value);
				d.data._dname[fid] = $('d_dname_' + fid).value;
				d.data._name[fid] = $('d_name_' + fid).value;
			});
		},

		'initForum': function () {

			var ex = /([^\d]+)(\d+)$/;

			d.data.getCate(function (fid, obj) {
				var fid = (ex.exec(obj.id) || ['', '', 0])[2];
				if(fid > 0) {
					d.data._forum[fid] = -1;
					obj.setAttribute('fid', fid);
				}
			});

			d.data.getForumByTag(0, function (fid, obj) {
				var fid = (ex.exec(obj.id) || ['', '', 0])[2],
				    fup = obj.getAttribute('fup');
				if(d.data.cate(fup)) {
					d.data._forum[fid] = fup;
					obj.setAttribute('fid', fid);
				}
			});

		}

	};

	/* קʵּ¼Ӧ */
	d.drag = {

		'_element': {'self': null, 'parent': null, 'cover': null, 'temp': null},
		'_event': {'mousemove': null, 'mouseup': null, 'selectstart': null},
		'_fid': 0,
		'_mode': 0,
		'_status': {'drag': false, 'button': false},

		'evtHide': function (fid) {
			if(!d.setting.hide || d.drag._status.drag) {
				return;
			}
			var obj = $('d_' + fid + '_hide');
			if(d.data._hidden[fid]) {
				obj.className = 'show';
				d.html.setText(obj, d.lang.cate.show);
				d.data._hidden[fid] = 0;
			} else {
				obj.className = 'hidden';
				d.html.setText(obj, d.lang.cate.hidden);
				d.data._hidden[fid] = 1;
			}
		},

		'evtName': function (fid) {
			if(!d.setting.modify || d.drag._status.drag) {
				return;
			}
			var name = d.data._dname[fid],
			    message = '<input id="d_newname" type="text" style="width: 200px;" value="" /><br />' + d.lang.message.input_text;
			showDialog(message, 'notice', d.lang.message.input_title, function () {
				var newname = trim($('d_newname').value),
				    sysname = d.data._name[fid];
				if(newname == name) {
					return;
				}
				if(newname) {
					d.html.setText($('d_' + fid + '_sname'), [newname, ['span', sysname]]);
					d.data._dname[fid] = newname;
				} else {
					d.html.setText($('d_' + fid + '_sname'), [sysname]);
					d.data._dname[fid] = '';
				}
			});
			$('d_newname').value = name;
		},

		'evtOut': function () {
			d.drag._status.button = false;
		},

		'evtOver': function () {
			d.drag._status.button = true;
		},

		'init': function () {
			d.data.init();
			d.drag.initElement();
			d.drag.initMode();
		},

		'initElement': function () {
			d.data.get(d.drag.initElementNode);
		},

		'initElementNode': function (fid) {

			if(d.setting.modify) {
				var obj = $('d_' + fid + '_name')
				obj.onclick =  function () { d.drag.evtName(fid); };
				obj.onmouseover = d.drag.evtOver;
				obj.onmouseout = d.drag.evtOut;
			}

			if(d.setting.hide) {
				var obj = $('d_' + fid + '_hide');
				if(d.data._hidden[fid]) {
					obj.className = 'hidden';
					d.html.setText(obj, d.lang.cate.hidden);
				} else {
					obj.className = 'show';
					d.html.setText(obj, d.lang.cate.show);
				}
				obj.onclick = function () { d.drag.evtHide(fid); };
				obj.onmouseover = d.drag.evtOver;
				obj.onmouseout = d.drag.evtOut;
			}

			$('d_' + fid).onmousedown =  function () { d.drag.onMousedown(fid); };

		},

		'initMode': function () {
			$('d_mode_cate').onclick = function () { d.drag.mode(1); };
			$('d_mode_forum').onclick = function () { d.drag.mode(2); };
			d.drag.mode(2);
		},

		'mode': function (id) {
			if(d.drag._status.drag || id == d.drag._mode) {
				return;
			}
			if(id == 1) {
				$('d_mode_cate').className = 'current';
				$('d_mode_forum').className = 'link';
				d.data.getCate(function (fid, obj) {
					obj.className += ' d_cate_h';
				});
			} else {
				$('d_mode_cate').className = 'link';
				$('d_mode_forum').className = 'current';
				d.data.getCate(function (fid, obj) {
					obj.className = obj.className.replace(/(.+?) d_cate_h/, '$1');
				});
			}
			d.drag._mode = id;
		},

		'onMousedown': function (fid) {

			if(d.drag._status.drag || d.drag._status.button) {
				return;
			}

			if(d.data.cate(fid)) {
				if(d.drag._mode != 1) {
					return;
				}
			} else {
				if(d.drag._mode != 2) {
					return;
				}
			}

			var obj = $('d_' + fid),
			    name = d.data._dname[fid] || d.data._name[fid];

			d.drag._status.drag = true;
			d.drag._element.self = obj.cloneNode(true);
			d.drag._element.parent = obj.parentNode;

			if(d.data.cate(fid)) {
				var temp = document.createElement('div');
				temp.setAttribute('name', 'd_cate[]');
				temp.className = 'bm bmw cl d_cate d_cate_e';
				temp.style.height = temp.style.lineHeight = obj.clientHeight.toString() + 'px';
				temp.innerHTML = name;
			} else {
				var fup = d.data._forum[fid],
				    temp = document.createElement('tr'),
				    td1 = document.createElement('td'), td2 = td1.cloneNode(true), td3 = td1.cloneNode(true);
				temp.setAttribute('fup', fup);
				temp.setAttribute('name', 'd_forum[]');
				temp.className = 'fl_row d_cate_etd';
				td1.innerHTML = td3.innerHTML = '&nbsp;';
				td2.innerHTML = name;
				temp.appendChild(td1);
				temp.appendChild(td2);
				temp.appendChild(td3);
				/* IE8/IE9 µ TR ĸ߶ȣ IE7 ֲ淶 TR ᱻŴҲû취ԭҰ = = */
				if(BROWSER.ie) {
					var el = obj.firstChild;
					while(el) {
						if(el.tagName == 'TD' && el.offsetHeight) {
							temp.style.height = el.offsetHeight.toString() + 'px';
							break;
						}
						el = el.nextSibling;
					}
				} else {
					temp.style.height = obj.clientHeight.toString() + 'px';
				}
			}

			temp.id = 'd_' + fid;
			temp.setAttribute('fid', fid);

			var next = obj.nextSibling;
			d.drag._element.parent.removeChild(obj);
			d.drag._element.parent.insertBefore(temp, next);

			d.drag._element.cover = temp;
			d.drag._element.temp = $('d_' + fid);

			d.drag._event.mousemove = document.body.onmousemove;
			d.drag._event.mouseup = document.body.onmouseup;
			d.drag._event.selectstart = document.body.onselectstart;

			document.body.onmousemove = function () { d.drag.onMousemove(fid); };
			document.body.onmouseup = function () { d.drag.onMouseup(fid); };
			document.body.onselectstart = function () { return false; };

		},

		'onMousemove': function (fid) {

			var y = getEvent().clientY + Math.max(document.documentElement.scrollTop, document.body.scrollTop),
			    pos = [], fids = [0, 0];

			if(d.data.cate(fid)) {
				d.data.getCate(function (f, obj) {
					pos.push([f, fetchOffset(obj).top, obj.offsetHeight]);
				});
			} else {
				d.data.getForumByTag(d.data._forum[fid], function (f, obj) {
					pos.push([f, fetchOffset(obj).top, obj.offsetHeight]);
				});
			}

			var maxlen = pos.length - 1;

			if(y < pos[0][1]) {
				fids[0] = fids[1] = pos[0][0];
			} else if(y > (pos[maxlen][1] + pos[maxlen][2])) {
				fids[1] = pos[maxlen][0];
			} else {
				for(var i = 0; i < pos.length; i++) {
					var exist = pos[i][0] == fid ? true : exist,
					    nextstart = (pos[i + 1] || [0, pos[i][1] + pos[i][2]])[1];
					if(pos[i][1] <= y && nextstart >= y) {
						fids[1] = pos[i][0];
						if(exist) {
							fids[0] = (pos[i + 1] || [0])[0];
						} else {
							fids[0] = fids[1];
						}
						break;
					}
				}
			}

			if(fids[1] == fid) {
				return;
			}

			var next = fids[0] ? $('d_' + fids[0]) : null;

			d.drag._element.parent.removeChild(d.drag._element.temp);
			d.drag._element.parent.insertBefore(d.drag._element.cover, next);

			d.drag._element.temp = $('d_' + fid);

		},

		'onMouseup': function (fid) {

			if(!d.drag._status.drag) {
				return;
			}

			var parent = d.drag._element.temp.parentNode;
			    next = d.drag._element.temp.nextSibling;

			parent.removeChild(d.drag._element.temp);
			parent.insertBefore(d.drag._element.self, next);

			d.drag._status.drag = false;
			d.drag.initElementNode(fid);

			if(d.data.cate(fid)) {
				d.data.getForum(fid, function (f) {
					d.drag.initElementNode(f);
				});
			}

			document.body.onmousemove = d.drag._event.mousemove;
			document.body.onmouseup = d.drag._event.mouseup;
			document.body.onselectstart = d.drag._event.selectstart;

		}

	};

	/* HTML ǩ */
	d.html = {

		'get': function (name, tag, callback) {
			if(BROWSER.ie) {
				var el = document.getElementsByTagName(tag);
				for(var i = 0; i < el.length; i++) {
					if(el[i].getAttribute && el[i].getAttribute('name') == name) {
						callback(el[i]);
					}
				}
			} else {
				var el = document.getElementsByName(name);
				for(var i = 0; i < el.length; i++) {
					callback(el[i]);
				}
			}
		},

		'removeAll': function (obj) {
			var el = obj.firstChild;
			while(el) {
				obj.removeChild(el);
				el = obj.firstChild;
			}
		},

		'setText': function (obj, text) {

			if(typeof text == 'string') {
				d.html.setText(obj, [text]);
				return;
			} else if(typeof text != 'object') {
				return;
			}

			d.html.removeAll(obj);

			for(var i = 0; i < text.length; i++) {
				if(typeof text[i] == 'object') {
					var el = document.createElement(text[i][0]);
					el.appendChild(document.createTextNode(text[i][1]));
				} else {
					var el = document.createTextNode(text[i]);
				}
				obj.appendChild(el);
			}

		}

	};

	/* ק㴦ť¼Ӧ */
	d.layer = {

		'_element': null,
		'_object': [null, null],

		'evtCancel': function () {
			showDialog(d.lang.message.confirm_cancel, 'confirm', 'Drag Now!', function () {
				d.layer.nodeRestore();
			});
		},

		'evtDefault': function () {
			showDialog(d.lang.message.confirm_default, 'confirm', 'Drag Now!', function () {
				d.ui.showLoading('submit');
				d.pipe.open('forum.php?mod=index&d=4&do=default', [], function (cw) {
					d.ui.showLoading('refresh');
					window.location.reload();
				}, function () {
					d.ui.showTool();
				});
			});
		},

		'evtStart': function () {

			d.ui.showLoading('get');
			d.layer.nodeBackup();

			d.pipe.open('forum.php?mod=index&d=2', null, function (cw) {
				d.ui.showTool();
				d.layer.nodeParse(cw);
			}, function () {
				d.ui.showStart();
			}, function (cw) {
				return (cw.$('d_main')) ? true : false;
			});

		},

		'evtSubmit': function () {

			d.ui.showLoading('submit');

			var data = {'cate': [], 'forum': []};

			d.data.getCate(function (fid) {
				data.cate.push(fid + ',' + (d.data._hidden[fid] ? '1' : '0') + '|' + d.data._dname[fid]);
			});

			d.data.getForumByTag(0, function (fid, obj) {
				var fup = d.data._forum[fid];
				data.forum.push(fid + ',' + fup + ',' + (d.data._hidden[fid] ? '1' : '0') + '|' + d.data._dname[fid]);
			});

			d.pipe.open('forum.php?mod=index&d=4&do=save', data, function (cw) {
				var obj = cw.$('response');
				showDialog(obj.innerHTML, 'notice', 'Drag Now!', function () {
					window.location.reload();
				});
			}, function () {
				d.ui.showTool();
			});

		},

		'init': function () {
			var obj = $('d_main');
			if(obj) {
				d.layer._object = [obj.parentNode, obj.nextSibling];
				return true;
			} else {
				return false;
			}
		},

		'nodeBackup': function () {
			d.layer._element = $('d_main').cloneNode(true);
		},

		'nodeParse': function (cw) {
			try {
				var obj = cw.$('d_main').cloneNode(true);
				d.layer.nodeBackup();
				d.layer._object[0].removeChild($('d_main'));
				d.layer._object[0].insertBefore(obj, d.layer._object[1]);
				d.drag.init();
			} catch (e) {
				showDialog(d.lang.message.browser, 'notice', 'Drag Now!', function () {
					window.location.reload();
				});
			}
		},

		'nodeRestore': function () {
			d.layer._object[0].removeChild($('d_main'));
			d.layer._object[0].insertBefore(d.layer._element, d.layer._object[1]);
			d.ui.showStart();
		}

	};

	/* ͨŹܵ */
	d.pipe = {

		'_handle': [],
		'_object': {'form': null, 'frame': null},
		'_working': false,

		'init': function () {

			d.pipe._object.form = $('dragnow_form');
			d.pipe._object.frame = $('dragnow_frame');

			if(!d.pipe._object.form || !d.pipe._object.frame) {
				return false;
			}

			/* Ϊ˼ IE7/IE8 */
			if(BROWSER.ie && BROWSER.ie < '9.0') {
				d.pipe._object.frame.onreadystatechange = function () {
					if(d.pipe._object.frame.readyState == 'complete') {
						d.pipe.respond();
					}
				};
			} else {
				d.pipe._object.frame.onload = d.pipe.respond;
			}

			return true;

		},

		'open': function (url, data, s, f, v) {

			if(typeof s != 'function') {
				var s = function (cw) { };
			}
			if(typeof f != 'function') {
				var f = function (e) { };
			}
			if(typeof v != 'function') {
				var v = function (cw) { return true };
			}

			url += '&f=' + d.hash + '&s=' + Math.random();

			d.pipe._handle = [s, f, v];
			d.pipe._working = true;

			if(typeof data == 'object' && data != null) {
				d.pipe.send(url, data);
			} else {
				d.pipe._object.frame.src = url;
			}

		},

		'respond': function () {

			if(d.pipe._working) {
				d.pipe._working = false;
			} else {
				return;
			}

			var cw = d.pipe._object.frame.contentWindow;
			var lang = d.lang.message.error_connect;

			if(typeof cw == 'object' && cw != null) {
				lang = d.lang.message.error_invalid;
				if(typeof cw.$ == 'function') {
					var result = d.pipe._handle[2](cw);
					if(result === true) {
						d.pipe._handle[0](cw);
						return;
					} else if(typeof result == 'string') {
						lang = result;
					}
				}
			}

			showDialog(lang, 'notice', 'Drag Now!', d.pipe._handle[1]);

		},

		'send': function (url, data) {

			d.pipe._object.form.action = url;
			d.html.removeAll(d.pipe._object.form);

			data.formhash = d.hash;
			data.dsubmit = 'yes';

			for(var id in data) {
				if(typeof data[id] == 'object') {
					for(var i = 0; i < data[id].length; i++) {
						var obj = document.createElement('input');
						obj.setAttribute('name', id + '[]');
						obj.type = 'hidden';
						obj.value = data[id][i];
						d.pipe._object.form.appendChild(obj);
					}
				} else {
					var obj = document.createElement('input');
					obj.setAttribute('name', id);
					obj.type = 'hidden';
					obj.value = data[id];
					d.pipe._object.form.appendChild(obj);
				}
			}

			d.pipe._object.form.submit();

		}

	};

	/*  */
	d.ui = {

		'_object': null,

		'clear': function () {
			d.ui._object.innerHTML = '';
		},

		'drawButton': function (id, handle) {
			var obj = document.createElement('a');
			obj.className = id;
			obj.innerHTML = d.lang.button[id][0];
			obj.title = d.lang.button[id][1];
			obj.href = 'javascript: void(0);';
			obj.onclick = handle;
			d.ui._object.appendChild(obj);
		},

		'init': function () {

			if(d.setting.position > 0) {

				if($('dragnow')) {
					$('dragnow').parentNode.removeChild($('dragnow'));
				}

				var obj = document.createElement('div');
				obj.id = 'dragnow';

				switch(d.setting.position) {
					case 1:
						var p = $('pt'), n = null;
						if($('an')) {
							obj.style.cssFloat = 'left';
						} else {
							obj.style.cssFloat = 'right';
						}
						break;
					case 2:
						var p = $('ct'), n = p.firstChild;
						obj.style.cssFloat = 'right';
						break;
					case 3:
						var p = $('chart'), n = null;
						obj.style.cssFloat = 'right';
						obj.style.marginRight = '40px';
						break;
				}

				if(!p) {
					return false;
				}

				p.insertBefore(obj, n);

			}

			d.ui._object = $('dragnow');

			if(!d.ui._object) {
				return false;
			}

			d.ui._object.style.display = '';
			return true;

		},

		'showLoading': function (id) {
			var obj = document.createElement('span');
			obj.innerHTML = d.lang.loading[id];
			d.ui.clear();
			d.ui._object.appendChild(obj);
		},

		'showStart': function () {
			d.ui.clear();
			d.ui.drawButton('start', d.layer.evtStart);
		},

		'showTool': function () {
			d.ui.clear();
			d.ui.drawButton('default', d.layer.evtDefault);
			d.ui.drawButton('cancel', d.layer.evtCancel);
			d.ui.drawButton('submit', d.layer.evtSubmit);
		}

	};

	d.init = function () {
		if(!d.pipe.init() || !d.ui.init() || !d.layer.init()) {
			return;
		}
		d.pipe.init();
		d.ui.showStart();
	};

	_attachEvent(window, 'load', d.init);

})();
